import '@tensorflow/tfjs-backend-webgl';
import * as tfconv from '@tensorflow/tfjs-converter';
import * as deeplab from '@tensorflow-models/deeplab';

const createModel = async () => {

  console.log("Ezzzz")
  const base = 'pascal';        // set to your preferred model, out of `pascal`,
  // `cityscapes` and `ade20k`
  const quantizationBytes = 2;  // either 1, 2 or 4
  // use the getURL utility function to get the URL to the pre-trained weights
  const modelUrl = deeplab.getURL(base, quantizationBytes);
  const rawModel = await tfconv.loadGraphModel(modelUrl);
  const modelName = 'pascal';  // set to your preferred model, out of `pascal`,
  // `cityscapes` and `ade20k`
  return new deeplab.SemanticSegmentation(rawModel);
};

const model = createModel();
model.then(() => console.log(`Loaded the model successfully!`));

self.addEventListener('message', async (e) => {

  const { pixels, width, height } = e.data;

  console.log(pixels, width, height)

  var array = new Uint8ClampedArray(pixels);

  var image = new ImageData(array, width, height);

  console.log("model", await (await model).segment(image))

  console.log(e);

});